
CoCoALib - Feature #379

Iter for subsets/tuples

19 Jun 2013 19:01 - John Abbott

Status: Closed Start date: 19 Jun 2013

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Data Structures Estimated time: 0.00 hour

Target version: CoCoALib-0.99850 Spent time: 7.20 hours

Description

Add new iters for subsets/tuples.

[JAA see file ShortTerm/oscar.C]

Related issues:

Related to CoCoA-5 - Feature #622: New  function: RandomSubset Closed 12 Sep 2014

Related to CoCoALib - Design #1787: Iterator design: compatible with C++STL? ... In Progress 07 Mar 2024

History

#1 - 01 Apr 2014 17:41 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#2 - 07 Apr 2014 14:33 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#3 - 09 Jul 2014 18:04 - John Abbott

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#4 - 13 May 2015 09:56 - Redmine Admin

- Category set to Data Structures

#5 - 10 Dec 2023 20:42 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99850

- % Done changed from 0 to 40

I did this some time ago: it is in combinatorics.H.

I think there should be a version which iterates only over subsets of given cardinality: CoCoA-5 can do this, but CoCoALib not.

#6 - 10 Dec 2023 21:26 - John Abbott

- % Done changed from 40 to 60

I have now added a new ctor SubsetIter(n,k)  which iterates over all subsets of cardinality k.

Still do not have an iterator for tuples.

#7 - 08 Feb 2024 21:37 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 60 to 90
I have now added a first impl of TupleIter following the idea behind SubsetIter, i.e. the tuples are from the set 0,1,...n-1.

Also added an example, and doc.

#8 - 23 Feb 2024 12:07 - John Abbott

ANNA will test this over the next week :-)

#9 - 07 Mar 2024 19:26 - John Abbott

ANNA  have you tested this?

#10 - 07 Mar 2024 19:52 - John Abbott

- Related to Design #1787: Iterator design: compatible with C++STL? Advancing beyond end? added

#11 - 08 Mar 2024 17:34 - Anna Maria Bigatti

John Abbott wrote:

ANNA  have you tested this?

 

I need to find where I wanted to use them: search in examples and tests (in particular code with Eduardo SysReliability, MVT, Taylor)

#12 - 13 Mar 2024 18:25 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

Tested in ex-Taylor(2).   Smooth.

I also added and example (2-subsets in {0,1,2,3}) in ex-combinatoric1.C
